import * as React from 'react';
import { ReactNode } from 'react';
export declare type ScrollableFeedVirtualizedProps = {
    itemHeight: number;
    marginTop: number;
    animateScroll?: (element: HTMLElement, offset: number) => void;
    onScrollComplete?: () => void;
    changeDetectionFilter?: (previousProps: ScrollableFeedVirtualizedComponentProps, newProps: ScrollableFeedVirtualizedComponentProps) => boolean;
    viewableDetectionEpsilon?: number;
    className?: string;
    onScroll?: (isAtBottom: boolean) => void;
};
declare type ScrollableFeedVirtualizedComponentProps = Readonly<{
    children?: ReactNode;
}> & Readonly<ScrollableFeedVirtualizedProps>;
declare class ScrollableFeedVirtualized extends React.Component<ScrollableFeedVirtualizedProps> {
    private readonly wrapperRef;
    private readonly topRef;
    private readonly bottomRef;
    private forceScroll;
    private skipForceScroll;
    private endIndex;
    private startIndexOverride;
    private endIndexOverride;
    constructor(props: ScrollableFeedVirtualizedProps);
    static defaultProps: ScrollableFeedVirtualizedProps;
    getSnapshotBeforeUpdate(): boolean;
    componentDidUpdate(previousProps: ScrollableFeedVirtualizedComponentProps, {}: any): void;
    componentDidMount(): void;
    /**
     * Scrolls a parent element such that the child element will be in view
     * @param parent
     * @param child
     */
    protected scrollParentToChild(parent: HTMLElement, child: HTMLElement): void;
    /**
     * Returns whether a child element is visible within a parent element
     *
     * @param parent
     * @param child
     * @param epsilon
     */
    private static isViewable;
    /**
     * Fires the onScroll event, sending isAtBottom boolean as its first parameter
     */
    protected handleScroll(): void;
    /**
     * Scroll to the bottom
     */
    scrollToBottom(): void;
    /**
     * Jump to the bottom
     */
    jumpToBottom(): void;
    render(): React.ReactNode;
}
export default ScrollableFeedVirtualized;
